/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./node_modules/xhr2/lib/browser.js":
/*!******************************************!*\
  !*** ./node_modules/xhr2/lib/browser.js ***!
  \******************************************/
/***/ ((module) => {

module.exports = XMLHttpRequest;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/BaseClient.ts":
/*!*******************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/BaseClient.ts ***!
  \*******************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.BaseClient = void 0;
var Util_1 = __webpack_require__(/*! ./lib/Util */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Util.ts");
var ClientSettings_1 = __webpack_require__(/*! ./ClientSettings */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ClientSettings.ts");
var XMLHttpRequest = __webpack_require__(/*! xhr2 */ "./node_modules/xhr2/lib/browser.js");
var BaseClient = (function () {
    function BaseClient(props) {
        if (!props)
            throw "You need to supply the props for the client";
        if (!props.ivUrl)
            throw "You need to specify url to ImageVault (props.ivUrl)";
        if (!props.clientIdentityAuth)
            throw "You need to provide client identity auth (props.clientIdentityAuth)";
        if (!props.ivUrl.endsWith("/"))
            props.ivUrl += "/";
        this.props = props;
        this.apiUrl = props.ivUrl + "apiv2/";
        this.redirectUrl = this.props.ivUrl + "Activate";
        this.settings = new ClientSettings_1.ClientSettings("ImageVault.Client:" + this.props.ivUrl);
    }
    BaseClient.prototype._addApiVersion = function (url) {
        if (!this.props.apiVersion || !url)
            return url;
        var versionQueryParameter = "v=" + this.props.apiVersion;
        if (url.indexOf("?") === -1) {
            return url + "?" + versionQueryParameter;
        }
        else {
            var qIndex = url.indexOf("?");
            var prefix = url.substring(0, qIndex);
            var query = url.substring(qIndex + 1);
            var pairs = query.split("&");
            var foundVersion = false;
            for (var i = 0; i < pairs.length; i++) {
                var keyValue = pairs[i].split("=");
                if (keyValue[0] === "v") {
                    pairs[i] = versionQueryParameter;
                    foundVersion = true;
                }
            }
            if (!foundVersion) {
                pairs.push(versionQueryParameter);
            }
            query = pairs.join("&");
            return prefix + "?" + query;
        }
    };
    BaseClient.prototype._call = function (options, resolve, reject) {
        if (!options)
            throw "You need to specify what to call";
        if (!options.path)
            throw "You need to specify options.path";
        var url = this.apiUrl + options.path;
        url = this._addApiVersion(url);
        var config = {
            async: Util_1.Util.get(options, "async", true),
            method: options.method || 'GET',
            url: url,
            headers: {},
            dataType: options.dataType || 'json',
            success: function (r) {
                try {
                    resolve(r);
                }
                catch (e) {
                    if (typeof e === "string") {
                        e = { message: e };
                    }
                    reject({ error: e });
                }
            },
            error: function (jqXHR, status, e) {
                var msg = e;
                if (jqXHR.responseJSON) {
                    msg = jqXHR.responseJSON.ExceptionMessage || jqXHR.responseJSON.Message || msg;
                }
                reject({ error: { message: msg }, jqXHR: jqXHR });
            }
        };
        if (options.auth) {
            config.headers['Authorization'] = options.auth;
        }
        if (options.contentType) {
            config.contentType = options.contentType;
        }
        if (options.data) {
            config.data = options.data;
        }
        this._ajax(config);
    };
    BaseClient.prototype._ajax = function (config) {
        var xhr = new XMLHttpRequest();
        xhr.open(config.method, config.url, config.async);
        if (config.dataType) {
            switch (config.dataType) {
                case "json":
                    config.headers["Accept"] = "application/json";
                    break;
            }
        }
        var csrfTokenElement = document.querySelector("input[name='__ApiRequestVerificationToken']");
        if (csrfTokenElement) {
            var csrfToken = csrfTokenElement.value;
            config.headers["__ApiRequestVerificationToken"] = csrfToken;
        }
        config.headers["Content-Type"] = config.contentType || 'application/x-www-form-urlencoded; charset=UTF-8';
        if (config.headers) {
            var keys = Object.keys(config.headers);
            for (var i = 0; i < keys.length; i++) {
                xhr.setRequestHeader(keys[i], config.headers[keys[i]]);
            }
        }
        xhr.onload = function () {
            if (xhr.status >= 200 && xhr.status < 300) {
                var response = xhr.responseText;
                switch (config.dataType || xhr.responseType) {
                    case "json":
                        if (response)
                            response = JSON.parse(response);
                        break;
                }
                config.success(response);
                return;
            }
            config.error({ status: xhr.status }, xhr.statusText, xhr.responseText);
        };
        xhr.onerror = function () {
            config.error({ status: xhr.status }, xhr.statusText, xhr.responseText);
        };
        xhr.onabort = function () {
            config.error({ status: xhr.status }, "Aborted", null);
        };
        var data = config.data;
        if (typeof (data) === "object") {
            if (config.headers["Content-Type"].startsWith("application/x-www-form-urlencoded")) {
                data = this.formUrlEncodeObject(data);
            }
            else if (config.headers["Content-Type"].startsWith("application/json")) {
                data = JSON.stringify(data);
            }
        }
        xhr.send(data);
    };
    BaseClient.prototype.formUrlEncodeObject = function (data, key, list) {
        if (key === void 0) { key = null; }
        if (list === void 0) { list = []; }
        var list = list || [];
        if (typeof (data) === 'object') {
            for (var idx in data)
                this.formUrlEncodeObject(data[idx], key ? key + '[' + idx + ']' : idx, list);
        }
        else {
            list.push(key + '=' + encodeURIComponent(data));
        }
        return list.join('&');
    };
    BaseClient.prototype.getAccessTokenSync = function (resolve, reject, tokenFailures) {
        this._getAccessToken(false, resolve, reject, tokenFailures);
    };
    BaseClient.prototype.getAccessToken = function (async) {
        return __awaiter(this, void 0, void 0, function () {
            var self;
            return __generator(this, function (_a) {
                self = this;
                if (!this.getAccessTokenPromise) {
                    this.getAccessTokenPromise = new Promise(function (resolve, reject) {
                        self._getAccessToken(async, resolve, reject, 0);
                    });
                }
                return [2, this.getAccessTokenPromise];
            });
        });
    };
    BaseClient.prototype._getAccessToken = function (async, resolve, reject, tokenFailures) {
        var self = this;
        var accessToken = this.settings.getAccessToken();
        if (accessToken) {
            resolve({ accessToken: accessToken });
            return;
        }
        var refreshToken = this.settings.getRefreshToken();
        if (refreshToken) {
            var data = {
                grant_type: "refresh_token",
                refresh_token: refreshToken
            };
            self._call({
                method: "POST",
                path: 'oauth/token',
                contentType: 'application/x-www-form-urlencoded',
                data: data,
                auth: self.props.clientIdentityAuth,
                async: async
            }, function (r) {
                var accessToken = r.token_type + " " + r.access_token;
                self.settings.setAccessToken(accessToken);
                self.settings.setRefreshToken(r.refresh_token);
                resolve({ accessToken: accessToken });
            }, function (r) {
                if (tokenFailures & 2) {
                    reject(r);
                    return;
                }
                self.settings.setAccessToken(null);
                self.settings.setRefreshToken(null);
                self._getAccessToken(async, resolve, reject, tokenFailures | 2);
            });
            return;
        }
        this.getAccessCode(async, function (r) {
            self.accessCodeResponse = r;
            self.requestAccessToken(async, resolve, reject);
        }, reject);
    };
    BaseClient.prototype.requestAccessToken = function (async, resolve, reject) {
        var self = this;
        var data = {
            "grant_type": "authorization_code",
            "code": self.accessCodeResponse.code,
            "redirect_uri": self.redirectUrl
        };
        self._call({
            method: "POST",
            path: 'oauth/token',
            contentType: 'application/x-www-form-urlencoded',
            data: data,
            auth: self.props.clientIdentityAuth,
            async: async
        }, function (r) {
            var accessToken = r.token_type + " " + r.access_token;
            self.settings.setAccessToken(accessToken);
            self.settings.setRefreshToken(r.refresh_token);
            resolve({ accessToken: accessToken });
        }, reject);
    };
    BaseClient.prototype.callWithUserAuth = function (options, resolve, reject) {
        var self = this;
        var isAsync = Util_1.Util.get(options, "async", true);
        this.getAccessToken(isAsync).then(function (r) {
            options.auth = r.accessToken;
            self._call(options, resolve, function (reason) {
                if (reason && reason.jqXHR && reason.jqXHR.status === 401) {
                    var oldAccessToken = self.settings.getAccessToken();
                    if (oldAccessToken) {
                        self.settings.setAccessToken(null);
                        self.getAccessTokenPromise = null;
                    }
                    self.getAccessToken(isAsync).then(function (r) {
                        options.auth = r.accessToken;
                        self._call(options, resolve, reject);
                    }).catch(function (e) {
                        reject(e);
                    });
                    return;
                }
                reject(reason);
            });
        }).catch(function (e) {
            reject(e);
        });
    };
    BaseClient.prototype.callWithUserAuthSync = function (options, resolve, reject) {
        var self = this;
        this.getAccessTokenSync(function (r) {
            options.auth = r.accessToken;
            self._call(options, resolve, function (reason) {
                if (reason && reason.jqXHR && reason.jqXHR.status === 401) {
                    self.settings.setAccessToken(null);
                    self.getAccessTokenSync(function (r) {
                        options.auth = r.accessToken;
                        self._call(options, resolve, reject);
                    }, reject, 1);
                    return;
                }
                reject(reason);
            });
        }, reject, 0);
    };
    BaseClient.prototype.get = function (path, resolve, reject) {
        var self = this;
        if (resolve) {
            return this.callWithUserAuth({ method: "GET", path: path }, resolve, reject);
        }
        else {
            return new Promise(function (resolve, reject) {
                self.callWithUserAuth({ method: "GET", path: path }, resolve, reject);
            });
        }
    };
    BaseClient.prototype.processPostOptions = function (options) {
        var defaultCallOptions = { method: "POST", contentType: "application/json" };
        options = Object.assign(defaultCallOptions, options);
        return options;
    };
    BaseClient.prototype.post = function (options, resolve, reject) {
        var self = this;
        options = this.processPostOptions(options);
        if (resolve) {
            return this.callWithUserAuth(options, resolve, reject);
        }
        else {
            return new Promise(function (resolve, reject) {
                self.callWithUserAuth(options, resolve, reject);
            });
        }
    };
    BaseClient.prototype.postSync = function (options) {
        options = Object.assign({}, options);
        options.async = false;
        var r = null;
        var error = null;
        options = this.processPostOptions(options);
        this.callWithUserAuthSync(options, function (result) { r = result; }, function (e) { error = e; });
        if (error)
            throw error;
        return r;
    };
    BaseClient.prototype.getCachedAccessToken = function () {
        return this.settings.getAccessToken();
    };
    BaseClient.prototype.json = function (path, argument, resolve, reject) {
        return this.post({ path: path, data: argument }, resolve, reject);
    };
    BaseClient.prototype.hasCachedCredentials = function () {
        return !!this.settings.getAccessToken() || !!this.settings.getRefreshToken();
    };
    BaseClient.prototype.removeCachedCredentials = function () {
        this.settings.setAccessToken(null);
        this.settings.setRefreshToken(null);
    };
    return BaseClient;
}());
exports.BaseClient = BaseClient;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ClientCredentialsClient.ts":
/*!********************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ClientCredentialsClient.ts ***!
  \********************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ClientCredentialsClient = void 0;
var BaseClient_1 = __webpack_require__(/*! ./BaseClient */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/BaseClient.ts");
var ClientCredentialsClient = (function (_super) {
    __extends(ClientCredentialsClient, _super);
    function ClientCredentialsClient(props) {
        return _super.call(this, props) || this;
    }
    ClientCredentialsClient.prototype.getAccessCode = function (async, resolve, reject) {
        resolve({ code: "Not_Used" });
    };
    ClientCredentialsClient.prototype.requestAccessToken = function (async, resolve, reject) {
        var self = this;
        var data = {
            "grant_type": "client_credentials"
        };
        if (this.props.impersonateAs) {
            data["impersonate_as"] = this.props.impersonateAs.username;
            if (this.props.impersonateAs.roles && this.props.impersonateAs.roles.length)
                data["roles"] = this.props.impersonateAs.roles;
        }
        var formData = self._call({
            method: "POST",
            path: 'oauth/token',
            contentType: 'application/x-www-form-urlencoded',
            data: data,
            auth: self.props.clientIdentityAuth,
            async: async
        }, function (r) {
            var accessToken = r.token_type + " " + r.access_token;
            self.settings.setAccessToken(accessToken);
            self.settings.setRefreshToken(r.refresh_token);
            resolve({ accessToken: accessToken });
        }, reject);
    };
    return ClientCredentialsClient;
}(BaseClient_1.BaseClient));
exports.ClientCredentialsClient = ClientCredentialsClient;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ClientSettings.ts":
/*!***********************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ClientSettings.ts ***!
  \***********************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ClientSettings = void 0;
var Settings_1 = __webpack_require__(/*! ./lib/Settings */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Settings.ts");
var ClientSettings = exports.ClientSettings = (function (_super) {
    __extends(ClientSettings, _super);
    function ClientSettings() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ClientSettings.prototype.getAccessToken = function () {
        return _super.prototype.loadSettings.call(this, ClientSettings.accessTokenKey, null);
    };
    ClientSettings.prototype.setAccessToken = function (accessToken) {
        _super.prototype.saveSetting.call(this, ClientSettings.accessTokenKey, accessToken);
    };
    ClientSettings.prototype.getRefreshToken = function () {
        return _super.prototype.loadSettings.call(this, ClientSettings.refreshTokenKey, null);
    };
    ClientSettings.prototype.setRefreshToken = function (refreshToken) {
        _super.prototype.saveSetting.call(this, ClientSettings.refreshTokenKey, refreshToken);
    };
    ClientSettings.accessTokenKey = "at";
    ClientSettings.refreshTokenKey = "rt";
    return ClientSettings;
}(Settings_1.Settings));


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/PinClient.ts":
/*!******************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/PinClient.ts ***!
  \******************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.PinClient = exports.ActivationResponse = exports.ActivationResponseState = void 0;
var Util_1 = __webpack_require__(/*! ./lib/Util */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Util.ts");
var BaseClient_1 = __webpack_require__(/*! ./BaseClient */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/BaseClient.ts");
var ActivationResponseState;
(function (ActivationResponseState) {
    ActivationResponseState[ActivationResponseState["tentative"] = 0] = "tentative";
    ActivationResponseState[ActivationResponseState["completed"] = 1] = "completed";
    ActivationResponseState[ActivationResponseState["error"] = 2] = "error";
})(ActivationResponseState || (exports.ActivationResponseState = ActivationResponseState = {}));
var ActivationResponse = (function () {
    function ActivationResponse() {
    }
    return ActivationResponse;
}());
exports.ActivationResponse = ActivationResponse;
var PinClient = (function (_super) {
    __extends(PinClient, _super);
    function PinClient(props) {
        var _this = _super.call(this, props) || this;
        _this.defaultTexts = {
            pin_code_request_no_valid_pin_code: "Pin code request did not return a valid pin code",
            poll_pin_failed_async_is_not_supported: "Poll pin failed since async calls is not supported",
            poll_pin_code_returned_state_x: "Poll pin code returned state {0}",
            no_access_code_was_returned_from_poll_code_response: "No access code was returned from poll code response",
            activation_completed: "Activation completed",
            activation_is_required_go_to_x_to_activate: "Activation is required. Go to {0} to activate"
        };
        if (!props.activationCallback)
            throw "You need to provide an activation callback (props.activationCallback)";
        _this.activateUrl = _this.props.ivUrl + "Activate";
        return _this;
    }
    PinClient.prototype.pinCodeRequest = function (async, resolve, reject) {
        var _this = this;
        var self = this;
        this._call({
            path: 'oauth/authorize?response_type=code&code_type=pin',
            auth: this.props.clientIdentityAuth,
            async: async
        }, function (r) {
            var activationUrl = self.activateUrl + "/" + r.pin;
            var activationMessage = {
                state: ActivationResponseState.tentative,
                htmlMessage: self.translate("activation_is_required_go_to_x_to_activate", "<a href='" + activationUrl + "' target='_blank'>" + activationUrl + "</a>")
            };
            _this.props.activationCallback(activationMessage);
            resolve(r);
        }, reject);
    };
    PinClient.prototype.translate = function (text) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var t = "[" + text + "]";
        if (this.props.i18n && this.props.i18n.hasOwnProperty(text)) {
            t = this.props.i18n[text];
        }
        else if (this.defaultTexts && this.defaultTexts.hasOwnProperty(text)) {
            t = this.defaultTexts[text];
        }
        t = Util_1.Util.formatString.apply(Util_1.Util, __spreadArray([t], __read(args), false));
        return t;
    };
    PinClient.prototype.pollPinCode = function (async, resolve, reject) {
        var self = this;
        if (!this.pin) {
            this.pinCodeRequest(async, function (r) {
                self.pin = r.pin;
                if (!self.pin) {
                    reject({ error: { message: self.translate("pin_code_request_no_valid_pin_code") } });
                    return;
                }
                self.pollPinCode(async, resolve, reject);
            }, reject);
            return;
        }
        this._call({
            path: 'oauth/authorize?response_type=code&code_type=pin&pin=' + this.pin,
            auth: this.props.clientIdentityAuth,
            async: async
        }, function (r) {
            resolve(r);
        }, reject);
    };
    PinClient.prototype.monitorPinCode = function (async, resolve, reject) {
        var _this = this;
        var self = this;
        this.monitorPinCodeResolve = resolve;
        this.monitorPinCodeReject = reject;
        if (this.monitorPinCodeTimeout) {
            clearTimeout(this.monitorPinCodeTimeout);
        }
        var pinFunc = function () {
            self.pollPinCode(async, function (r) {
                if (r.state == "granted") {
                    self.monitorPinCodeResolve(r);
                    return;
                }
                if (!async) {
                    throw self.translate("poll_pin_failed_async_is_not_supported");
                }
                if (r.state == "tentative") {
                    self.monitorPinCodeTimeout = setTimeout(pinFunc, 1000);
                    return;
                }
                throw self.translate("poll_pin_code_returned_state_x", r.state);
            }, _this.monitorPinCodeReject);
        };
        pinFunc();
    };
    PinClient.prototype.getAccessCode = function (async, resolve, reject) {
        var self = this;
        if (this.accessCode) {
            resolve(this.accessCode);
            return;
        }
        this.monitorPinCode(async, function (r) {
            self.accessCode = r;
            if (!self.accessCode) {
                var msg = self.translate("no_access_code_was_returned_from_poll_code_response");
                self.props.activationCallback({ state: ActivationResponseState.error, htmlMessage: msg });
                reject({ error: { message: msg } });
                return;
            }
            self.props.activationCallback({ state: ActivationResponseState.completed, htmlMessage: self.translate("activation_completed") });
            resolve(self.accessCode);
        }, function (reason) {
            self.props.activationCallback({ state: ActivationResponseState.error, htmlMessage: reason.error.message });
            reject(reason);
        });
    };
    return PinClient;
}(BaseClient_1.BaseClient));
exports.PinClient = PinClient;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/data/AgreementSymbolStates.ts":
/*!***********************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/data/AgreementSymbolStates.ts ***!
  \***********************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AgreementSymbolStates = void 0;
var AgreementSymbolStates;
(function (AgreementSymbolStates) {
    AgreementSymbolStates[AgreementSymbolStates["Unknown"] = 0] = "Unknown";
    AgreementSymbolStates[AgreementSymbolStates["Valid"] = 1] = "Valid";
    AgreementSymbolStates[AgreementSymbolStates["ValidButSoonInvalid"] = 2] = "ValidButSoonInvalid";
    AgreementSymbolStates[AgreementSymbolStates["NotSet"] = 3] = "NotSet";
    AgreementSymbolStates[AgreementSymbolStates["Invalid"] = 4] = "Invalid";
    AgreementSymbolStates[AgreementSymbolStates["Mixed"] = 5] = "Mixed";
})(AgreementSymbolStates || (exports.AgreementSymbolStates = AgreementSymbolStates = {}));


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/data/ApiVersion.ts":
/*!************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/data/ApiVersion.ts ***!
  \************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ApiVersion = void 0;
var ApiVersion;
(function (ApiVersion) {
    ApiVersion[ApiVersion["V0"] = 0] = "V0";
    ApiVersion[ApiVersion["V526"] = 1] = "V526";
})(ApiVersion || (exports.ApiVersion = ApiVersion = {}));


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/data/AssetSymbol.ts":
/*!*************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/data/AssetSymbol.ts ***!
  \*************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AssetSymbol = void 0;
var AssetSymbol = (function () {
    function AssetSymbol(symbol, info) {
        this.symbol = symbol;
        this.info = info;
    }
    return AssetSymbol;
}());
exports.AssetSymbol = AssetSymbol;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/effects.ts":
/*!****************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/effects.ts ***!
  \****************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ExportMetadataEffect = exports.ExportMetadataTypes = exports.ChangeOutputFormatEffect = exports.TrimEffect = exports.CropEffect = exports.ResizeEffect = void 0;
var ResizeEffect = exports.ResizeEffect = (function () {
    function ResizeEffect(width, height, resizeMode) {
        this.$type = "".concat(ResizeEffect.typeName, ",").concat(ResizeEffect.assemblyName);
        this.ResizeMode = 0;
        this.Width = width;
        this.Height = height;
        this.ResizeMode = resizeMode;
    }
    ResizeEffect.typeName = "ImageVault.Common.Data.Effects.ResizeEffect";
    ResizeEffect.assemblyName = "ImageVault.Common";
    return ResizeEffect;
}());
var CropEffect = exports.CropEffect = (function () {
    function CropEffect(x, y, width, height) {
        this.$type = "".concat(CropEffect.typeName, ",").concat(CropEffect.assemblyName);
        this.X = x;
        this.Y = y;
        this.Width = width;
        this.Height = height;
    }
    CropEffect.typeName = "ImageVault.Common.Data.Effects.CropEffect";
    CropEffect.assemblyName = "ImageVault.Common";
    return CropEffect;
}());
var TrimEffect = exports.TrimEffect = (function () {
    function TrimEffect(start, stop) {
        this.$type = "".concat(TrimEffect.typeName, ",").concat(TrimEffect.assemblyName);
        this.Start = start;
        this.Stop = stop;
    }
    TrimEffect.typeName = "ImageVault.Common.Data.Effects.TrimEffect";
    TrimEffect.assemblyName = "ImageVault.Common";
    return TrimEffect;
}());
var ChangeOutputFormatEffect = exports.ChangeOutputFormatEffect = (function () {
    function ChangeOutputFormatEffect(contentType) {
        this.$type = "".concat(ChangeOutputFormatEffect.typeName, ",").concat(ChangeOutputFormatEffect.assemblyName);
        this.ContentType = contentType;
    }
    ChangeOutputFormatEffect.typeName = "ImageVault.Common.Data.Effects.ChangeOutputFormatEffect";
    ChangeOutputFormatEffect.assemblyName = "ImageVault.Common";
    return ChangeOutputFormatEffect;
}());
var ExportMetadataTypes;
(function (ExportMetadataTypes) {
    ExportMetadataTypes[ExportMetadataTypes["None"] = 0] = "None";
    ExportMetadataTypes[ExportMetadataTypes["EmbeddedXmp"] = 1] = "EmbeddedXmp";
})(ExportMetadataTypes || (exports.ExportMetadataTypes = ExportMetadataTypes = {}));
var ExportMetadataEffect = exports.ExportMetadataEffect = (function () {
    function ExportMetadataEffect(metadataType) {
        this.$type = "".concat(ExportMetadataEffect.typeName, ",").concat(ExportMetadataEffect.assemblyName);
        this.MetadataType = metadataType;
    }
    ExportMetadataEffect.typeName = "ImageVault.Common.Data.Effects.ExportMetadataEffect";
    ExportMetadataEffect.assemblyName = "ImageVault.Common";
    return ExportMetadataEffect;
}());


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/formats.ts":
/*!****************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/formats.ts ***!
  \****************************************************************************************/
/***/ (function(__unused_webpack_module, exports) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ImageFormat = exports.ThumbnailFormat = exports.WebMediaFormat = exports.TransformableMediaFormat = exports.OriginalFormat = exports.MediaFormatOutputType = exports.MediaFormatBase = void 0;
var MediaFormatBase = (function () {
    function MediaFormatBase() {
    }
    return MediaFormatBase;
}());
exports.MediaFormatBase = MediaFormatBase;
var MediaFormatOutputType;
(function (MediaFormatOutputType) {
    MediaFormatOutputType[MediaFormatOutputType["Unknown"] = 9999] = "Unknown";
    MediaFormatOutputType[MediaFormatOutputType["WebSafe"] = 0] = "WebSafe";
    MediaFormatOutputType[MediaFormatOutputType["Jpeg"] = 1] = "Jpeg";
    MediaFormatOutputType[MediaFormatOutputType["Tiff"] = 2] = "Tiff";
    MediaFormatOutputType[MediaFormatOutputType["Png"] = 4] = "Png";
    MediaFormatOutputType[MediaFormatOutputType["Gif"] = 5] = "Gif";
    MediaFormatOutputType[MediaFormatOutputType["Original"] = 6] = "Original";
})(MediaFormatOutputType || (exports.MediaFormatOutputType = MediaFormatOutputType = {}));
var OriginalFormat = (function (_super) {
    __extends(OriginalFormat, _super);
    function OriginalFormat() {
        var _this = _super.call(this) || this;
        _this.Id = 0;
        return _this;
    }
    return OriginalFormat;
}(MediaFormatBase));
exports.OriginalFormat = OriginalFormat;
var TransformableMediaFormat = (function (_super) {
    __extends(TransformableMediaFormat, _super);
    function TransformableMediaFormat() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return TransformableMediaFormat;
}(MediaFormatBase));
exports.TransformableMediaFormat = TransformableMediaFormat;
var WebMediaFormat = exports.WebMediaFormat = (function (_super) {
    __extends(WebMediaFormat, _super);
    function WebMediaFormat(effects) {
        if (effects === void 0) { effects = null; }
        var _this = _super.call(this) || this;
        _this.$type = "".concat(WebMediaFormat.typeName, ",").concat(WebMediaFormat.assemblyName);
        _this.Effects = effects;
        return _this;
    }
    WebMediaFormat.typeName = "ImageVault.Common.Data.WebMediaFormat";
    WebMediaFormat.assemblyName = "ImageVault.Common";
    return WebMediaFormat;
}(TransformableMediaFormat));
var ThumbnailFormat = exports.ThumbnailFormat = (function (_super) {
    __extends(ThumbnailFormat, _super);
    function ThumbnailFormat() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.$type = "".concat(ThumbnailFormat.typeName, ",").concat(ThumbnailFormat.assemblyName);
        return _this;
    }
    ThumbnailFormat.typeName = "ImageVault.Common.Data.ThumbnailFormat";
    ThumbnailFormat.assemblyName = "ImageVault.Common";
    return ThumbnailFormat;
}(WebMediaFormat));
var ImageFormat = exports.ImageFormat = (function (_super) {
    __extends(ImageFormat, _super);
    function ImageFormat(mediaFormatOutputType, compressionQuality, effects) {
        if (mediaFormatOutputType === void 0) { mediaFormatOutputType = undefined; }
        if (compressionQuality === void 0) { compressionQuality = undefined; }
        if (effects === void 0) { effects = undefined; }
        var _this = _super.call(this) || this;
        _this.$type = "".concat(ImageFormat.typeName, ",").concat(ImageFormat.assemblyName);
        _this.MediaFormatOutputType = mediaFormatOutputType;
        _this.CompressionQuality = compressionQuality;
        _this.Effects = effects;
        return _this;
    }
    ImageFormat.typeName = "ImageVault.Common.Data.ImageFormat";
    ImageFormat.assemblyName = "ImageVault.Common";
    return ImageFormat;
}(ThumbnailFormat));


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/imagevault-client.ts":
/*!**************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/imagevault-client.ts ***!
  \**************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Client = void 0;
var JQuery = __webpack_require__(/*! jquery */ "jquery");
var $ = window.iv_jQuery != undefined ? window.iv_jQuery : JQuery;
var Client = (function () {
    function Client(config) {
        this.core = null;
        this.authUrl = null;
        this.username = null;
        this.password = null;
        this.authMethod = "active";
        this.impersonate_as = null;
        this.roles = null;
        this.authToken = null;
        this.accessToken = null;
        this._lastError = null;
        this.grant_type = null;
        this.resourceOwnerUsername = null;
        this.resourceOwnerPassword = null;
        this._Base64 = {
            _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
            encode: function (input) {
                var output = "";
                var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
                var i = 0;
                input = this._utf8_encode(input);
                while (i < input.length) {
                    chr1 = input.charCodeAt(i++);
                    chr2 = input.charCodeAt(i++);
                    chr3 = input.charCodeAt(i++);
                    enc1 = chr1 >> 2;
                    enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
                    enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
                    enc4 = chr3 & 63;
                    if (isNaN(chr2)) {
                        enc3 = enc4 = 64;
                    }
                    else if (isNaN(chr3)) {
                        enc4 = 64;
                    }
                    output = output +
                        this._keyStr.charAt(enc1) +
                        this._keyStr.charAt(enc2) +
                        this._keyStr.charAt(enc3) +
                        this._keyStr.charAt(enc4);
                }
                return output;
            },
            decode: function (input) {
                var output = "";
                var chr1, chr2, chr3;
                var enc1, enc2, enc3, enc4;
                var i = 0;
                input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
                while (i < input.length) {
                    enc1 = this._keyStr.indexOf(input.charAt(i++));
                    enc2 = this._keyStr.indexOf(input.charAt(i++));
                    enc3 = this._keyStr.indexOf(input.charAt(i++));
                    enc4 = this._keyStr.indexOf(input.charAt(i++));
                    chr1 = (enc1 << 2) | (enc2 >> 4);
                    chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                    chr3 = ((enc3 & 3) << 6) | enc4;
                    output = output + String.fromCharCode(chr1);
                    if (enc3 !== 64) {
                        output = output + String.fromCharCode(chr2);
                    }
                    if (enc4 !== 64) {
                        output = output + String.fromCharCode(chr3);
                    }
                }
                output = this._utf8_decode(output);
                return output;
            },
            _utf8_encode: function (string) {
                string = string.replace(/\r\n/g, "\n");
                var utftext = "";
                for (var n = 0; n < string.length; n++) {
                    var c = string.charCodeAt(n);
                    if (c < 128) {
                        utftext += String.fromCharCode(c);
                    }
                    else if ((c > 127) && (c < 2048)) {
                        utftext += String.fromCharCode((c >> 6) | 192);
                        utftext += String.fromCharCode((c & 63) | 128);
                    }
                    else {
                        utftext += String.fromCharCode((c >> 12) | 224);
                        utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                        utftext += String.fromCharCode((c & 63) | 128);
                    }
                }
                return utftext;
            },
            _utf8_decode: function (utftext) {
                var string = "";
                var i = 0;
                var c, c2, c3;
                while (i < utftext.length) {
                    c = utftext.charCodeAt(i);
                    if (c < 128) {
                        string += String.fromCharCode(c);
                        i++;
                    }
                    else if ((c > 191) && (c < 224)) {
                        c2 = utftext.charCodeAt(i + 1);
                        string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                        i += 2;
                    }
                    else {
                        c2 = utftext.charCodeAt(i + 1);
                        c3 = utftext.charCodeAt(i + 2);
                        string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                        i += 3;
                    }
                }
                return string;
            }
        };
        $.extend(this, config);
        if (this.core)
            if (this.core[this.core.length - 1] !== '/')
                this.core = this.core + "/";
        if (this.authUrl)
            if (this.authUrl[this.authUrl.length - 1] !== '/')
                this.authUrl = this.authUrl + "/";
    }
    Client.prototype.json = function (service, args, callback) {
        this._innerCall(service, args, callback, { dataType: 'JSON' });
    };
    Client.prototype.html = function (service, args, callback) {
        this._innerCall(service, args, callback, { dataType: 'HTML' });
    };
    Client.prototype._innerCall = function (service, args, callback, config) {
        var _this = this;
        this._lastError = null;
        if (typeof args === "function") {
            callback = args;
            args = null;
        }
        if (typeof args === "object" ||
            (typeof args === "string" && args.length > 0 && args.charAt(0) !== '{' && args.charAt(0) !== '[')) {
            args = JSON.stringify(args);
        }
        this._getAuthToken(function (token) {
            if (_this.authMethod === "none" || token !== null) {
                _this._callServiceWithToken(token, service, args, callback, config);
            }
            else {
                callback(null);
            }
        });
    };
    Client.prototype._makeAbsoluteUrl = function (url) {
        var a = document.createElement("a");
        a.href = url;
        url = a.href;
        return url;
    };
    Client.prototype._callServiceWithToken = function (token, service, args, callback, config) {
        var _this = this;
        var self = this;
        var url = self.core + service;
        var type = 'POST';
        if (args == null) {
            type = 'GET';
        }
        var headers = {};
        if (token != null) {
            headers["Authorization"] = token;
            headers["IVAuthorization"] = token;
        }
        var ajaxConfig = {
            url: self._makeAbsoluteUrl(url),
            type: type,
            data: args,
            contentType: 'application/json; charset=utf-8',
            headers: headers,
            success: function (data) {
                if (config.dataType === "JSON" && typeof data === "string")
                    data = JSON.parse(data);
                callback(data);
            },
            error: null
        };
        ajaxConfig = $.extend(ajaxConfig, config);
        var reAuthFunction = function (retryCall) {
            _this._reauthenticateUsingActiveAuthentication(retryCall);
        };
        var retryCallFunction = function (t) {
            if (t !== null) {
                ajaxConfig.headers["Authorization"] = t;
                ajaxConfig.headers["IVAuthorization"] = t;
            }
            reAuthFunction = null;
            _this._ajaxWithCorsSupport(ajaxConfig);
        };
        ajaxConfig.error = function (jqXhr, status, err) {
            if (jqXhr.status === 401 && typeof reAuthFunction === "function") {
                reAuthFunction(retryCallFunction);
            }
            else {
                var error = { message: err, status: jqXhr.status };
                _this._lastError = error;
                callback(null, error);
            }
        };
        self._ajaxWithCorsSupport(ajaxConfig);
    };
    Client.prototype._reauthenticateUsingActiveAuthentication = function (callback) {
        this.authToken = null;
        this.sessionToken = null;
        this._getAuthToken(callback);
    };
    Client.prototype._ajaxWithCorsSupport = function (config) {
        var oldSupportCors = $.support.cors;
        $.support.cors = true;
        config.crossDomain = true;
        config.xhrFields = { withCredentials: true };
        var csrfTokenElement = document.querySelector("input[name='__ApiRequestVerificationToken']");
        if (csrfTokenElement) {
            var csrfToken = csrfTokenElement.value;
            config.headers["__ApiRequestVerificationToken"] = csrfToken;
        }
        var oldComplete = config.complete;
        config.complete = function (jqXhr, status, responseText) {
            $.support.cors = oldSupportCors;
            if (typeof oldComplete === "function") {
                oldComplete(jqXhr, status, responseText);
            }
        };
        $.ajax(config);
    };
    Client.prototype._getAuthToken = function (callback) {
        var self = this;
        if (self.authMethod === "none") {
            self.authToken = null;
            callback(null);
            return;
        }
        if (self.authToken &&
            self.accessToken &&
            self.accessToken.expires_at &&
            self.accessToken.expires_at > new Date()) {
            callback(self.authToken);
            return;
        }
        var params = {
            grant_type: null,
            username: null,
            password: null,
            impersonate_as: null,
            roles: null
        };
        if (self.grant_type)
            params.grant_type = self.grant_type;
        else
            params.grant_type = 'client_credentials';
        if (self.resourceOwnerUsername && self.resourceOwnerPassword) {
            params.username = self.resourceOwnerUsername;
            params.password = self.resourceOwnerPassword;
        }
        if (self.impersonate_as)
            params.impersonate_as = self.impersonate_as;
        if (self.roles)
            params.roles = self.roles;
        var headers = {};
        if (self.username && self.password) {
            var untoken = "Basic " + self._Base64.encode(self.username + ":" + self.password);
            headers = { 'Authorization': untoken };
        }
        var url = this.authUrl;
        if (!url)
            url = this.core;
        url += "oauth/token";
        var config = {
            url: self._makeAbsoluteUrl(url),
            type: 'POST',
            headers: headers,
            contentType: 'application/x-www-form-urlencoded; charset=utf-8',
            cache: false,
            data: params,
            success: function (data) {
                var accessToken = self.accessToken = data;
                var expires = new Date();
                expires.setSeconds(expires.getSeconds() + accessToken.expires_in);
                self.accessToken.expires_at = expires;
                self.accessToken = accessToken;
                self.authToken = accessToken.token_type + " " + accessToken.access_token;
                callback(self.authToken);
            },
            error: function (xhr) {
                try {
                    var error = JSON.parse(xhr.responseText);
                    if (!error.message) {
                        error.message = error.error_description;
                    }
                    self._lastError = { status: xhr.status, message: error };
                }
                catch (e) {
                    self._lastError = { status: xhr.status, message: { message: xhr.responseText } };
                }
                callback(null, self._lastError);
            }
        };
        self._ajaxWithCorsSupport(config);
    };
    Client.prototype.getLastErrorMessage = function () {
        if (this._lastError && this._lastError.message)
            return this._lastError.message;
        return null;
    };
    return Client;
}());
exports.Client = Client;
(window.ImageVault = window.ImageVault || {}).Client = Client;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/ImageLoader.ts":
/*!************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/ImageLoader.ts ***!
  \************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ImageLoader = void 0;
var JQuery = __webpack_require__(/*! jquery */ "jquery");
var UriUtil_1 = __webpack_require__(/*! ./UriUtil */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/UriUtil.ts");
var ImageLoader = exports.ImageLoader = (function () {
    function ImageLoader() {
    }
    ImageLoader.getRetryAfterSeconds = function (retryAfterHeader) {
        var timeout = parseInt(retryAfterHeader) || 0;
        if (timeout <= 0)
            timeout = ImageLoader.minRetryTimeout;
        return timeout;
    };
    ImageLoader.loadAsync = function (src) {
        return new Promise(function (resolve, reject) {
            var validImageChecker;
            var checkImage = function () {
                JQuery.ajax({
                    url: src,
                    complete: function (response) {
                        validImageChecker(response);
                    }
                });
            };
            validImageChecker = function (response) {
                if (response) {
                    if (response.status >= 200 && response.status < 300) {
                        src = UriUtil_1.UriUtil.addQueryStringParameters(src, { t: new Date().getTime().toString() });
                        resolve(src);
                        return;
                    }
                    if (response.status === 503) {
                        var timeout = ImageLoader.getRetryAfterSeconds(response.getResponseHeader("Retry-After"));
                        setTimeout(function () {
                            checkImage();
                        }, timeout * 1000);
                        return;
                    }
                }
                reject(response);
            };
            checkImage();
        });
    };
    ImageLoader.minRetryTimeout = 3;
    return ImageLoader;
}());


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Settings.ts":
/*!*********************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Settings.ts ***!
  \*********************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Settings = void 0;
var Settings = (function () {
    function Settings(name) {
        this.name = name;
        this.storage = LocalStorageWrapper.create();
    }
    Settings.prototype.loadSettings = function (key, defaultValue) {
        var s = this.storage.getItem(this.name);
        var conf = {};
        if (s) {
            conf = JSON.parse(s);
        }
        if (key in conf) {
            return conf[key];
        }
        return defaultValue;
    };
    Settings.prototype.saveSetting = function (key, value) {
        var s = this.storage.getItem(this.name);
        var conf = {};
        if (s) {
            conf = JSON.parse(s);
        }
        conf[key] = value;
        s = JSON.stringify(conf);
        this.storage.setItem(this.name, s);
    };
    return Settings;
}());
exports.Settings = Settings;
var LocalStorageWrapper = (function () {
    function LocalStorageWrapper() {
        this.items = {};
    }
    LocalStorageWrapper.prototype.getItem = function (key) {
        if (this.items.hasOwnProperty(key))
            return this.items[key];
        return null;
    };
    LocalStorageWrapper.prototype.setItem = function (key, value) {
        this.items[key] = value;
    };
    LocalStorageWrapper.create = function () {
        if (typeof localStorage !== 'undefined')
            return localStorage;
        return new LocalStorageWrapper();
    };
    return LocalStorageWrapper;
}());


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/UriUtil.ts":
/*!********************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/UriUtil.ts ***!
  \********************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.UriUtil = void 0;
var UriUtil = (function () {
    function UriUtil() {
    }
    UriUtil.toQueryString = function (q) {
        if (!q)
            return "";
        var queryString = Object.keys(q).map(function (key) {
            return encodeURIComponent(key) + '=' + encodeURIComponent(q[key]);
        }).join('&');
        return queryString;
    };
    UriUtil.changeExtension = function (url, extension) {
        var rex = /^((?:(?:\w+:)?\/\/[^\/]+\/)?[^?]*?)(\.[^\.\?]*)?($|\?.*$)/i;
        if (!url)
            return url;
        var m = url.match(rex);
        if (!m)
            return url;
        extension = extension || "";
        if (extension && extension.length && extension[0] !== '.')
            extension = "." + extension;
        var newUrl = m[1] + extension + m[3];
        return newUrl;
    };
    UriUtil.getQueryStringParameters = function (url) {
        var p = {};
        if (!url)
            return p;
        var rex = /\?(.*)(\#.*)?$/i;
        var m = url.match(rex);
        if (!m)
            return p;
        var qs = m[1];
        if (!qs)
            return p;
        var kv = qs.split("&");
        for (var i = 0; i < kv.length; i++) {
            var pair = kv[i].split("=");
            var key = decodeURIComponent(pair[0]);
            var value = decodeURIComponent(pair.length > 1 ? pair[1] : "");
            p[key] = value;
        }
        return p;
    };
    UriUtil.stripQuery = function (url) {
        if (!url)
            return url;
        var i = url.indexOf("?");
        if (i >= 0)
            return url.substring(0, i);
        return url;
    };
    UriUtil.addQueryStringParameters = function (url, queryStringParams) {
        if (!url)
            return url;
        if (!queryStringParams || !Object.keys(queryStringParams).length)
            return url;
        var q = UriUtil.getQueryStringParameters(url);
        var baseUrl = UriUtil.stripQuery(url);
        if (!q || !Object.keys(q).length) {
            q = queryStringParams;
        }
        else {
            q = Object.assign(queryStringParams, q);
        }
        return baseUrl + "?" + UriUtil.toQueryString(q);
    };
    return UriUtil;
}());
exports.UriUtil = UriUtil;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Util.ts":
/*!*****************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Util.ts ***!
  \*****************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Util = void 0;
var Util = (function () {
    function Util() {
    }
    Util.has = function (object, key) {
        return object ? object.hasOwnProperty(key) : false;
    };
    Util.get = function (object, key, defaultValue) {
        return Util.has(object, key) ? object[key] : defaultValue;
    };
    Util.formatString = function (str) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (!str)
            return str;
        return str.replace(/{(\d+)}/g, function (a, b) {
            return args[b];
        });
    };
    Util.htmlEncode = function (str) {
        if (!str)
            return "";
        if ((typeof str) !== "string")
            str = str.toString();
        return str
            .replace(/&/g, '&amp;')
            .replace(/"/g, '&quot;')
            .replace(/'/g, '&#39;')
            .replace(/</g, '&lt;')
            .replace(/>/g, '&gt;')
            .replace(/\//g, '&#x2F;');
    };
    return Util;
}());
exports.Util = Util;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/AssetService.ts":
/*!******************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/AssetService.ts ***!
  \******************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AssetConversion = exports.AssetMetadata = exports.AssetCategory = exports.AssetService = void 0;
var UriUtil_1 = __webpack_require__(/*! ../lib/UriUtil */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/UriUtil.ts");
var AssetService = (function () {
    function AssetService() {
    }
    AssetService.info = function (client) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve, reject) {
                        client.get("assets/info", resolve, reject);
                    })];
            });
        });
    };
    AssetService.get = function (client, request) {
        var query = UriUtil_1.UriUtil.toQueryString(request);
        return new Promise(function (resolve, reject) {
            client.get("assets?" + query, resolve, reject);
        });
    };
    return AssetService;
}());
exports.AssetService = AssetService;
var AssetCategory = (function () {
    function AssetCategory() {
    }
    return AssetCategory;
}());
exports.AssetCategory = AssetCategory;
var AssetMetadata = (function () {
    function AssetMetadata() {
    }
    return AssetMetadata;
}());
exports.AssetMetadata = AssetMetadata;
var AssetConversion = (function () {
    function AssetConversion() {
    }
    return AssetConversion;
}());
exports.AssetConversion = AssetConversion;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/CategoryService.ts":
/*!*********************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/CategoryService.ts ***!
  \*********************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Category = exports.CategoryService = void 0;
var CategoryService = (function () {
    function CategoryService() {
    }
    CategoryService.getCategories = function (client) {
        return new Promise(function (resolve, reject) {
            client.get("CategoryService/GetCategories", resolve, reject);
        });
    };
    return CategoryService;
}());
exports.CategoryService = CategoryService;
var Category = (function () {
    function Category() {
    }
    return Category;
}());
exports.Category = Category;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/IVFilter.ts":
/*!**************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/IVFilter.ts ***!
  \**************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.IVFilter = void 0;
var IVFilter = (function () {
    function IVFilter() {
    }
    return IVFilter;
}());
exports.IVFilter = IVFilter;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MediaFormatService.ts":
/*!************************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MediaFormatService.ts ***!
  \************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.MediaFormatPopulationQuery = exports.MediaFormatFilter = exports.MediaFormatQuery = exports.MediaFormatService = void 0;
var IVFilter_1 = __webpack_require__(/*! ./IVFilter */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/IVFilter.ts");
var MediaFormatService = (function () {
    function MediaFormatService() {
    }
    MediaFormatService.Find = function (client, q) {
        return new Promise(function (resolve, reject) {
            client.post({ path: "MediaFormatService/Find", data: q }, resolve, reject);
        });
    };
    return MediaFormatService;
}());
exports.MediaFormatService = MediaFormatService;
var MediaFormatQuery = (function () {
    function MediaFormatQuery() {
    }
    return MediaFormatQuery;
}());
exports.MediaFormatQuery = MediaFormatQuery;
var MediaFormatFilter = (function (_super) {
    __extends(MediaFormatFilter, _super);
    function MediaFormatFilter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return MediaFormatFilter;
}(IVFilter_1.IVFilter));
exports.MediaFormatFilter = MediaFormatFilter;
var MediaFormatPopulationQuery = (function () {
    function MediaFormatPopulationQuery() {
    }
    return MediaFormatPopulationQuery;
}());
exports.MediaFormatPopulationQuery = MediaFormatPopulationQuery;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MediaService.ts":
/*!******************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MediaService.ts ***!
  \******************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.WebMedia = exports.Media = exports.AssetStates = exports.LegalBasis = exports.ConsentStatus = exports.ConsentUserAgreementData = exports.AgreementState = exports.ValidToDateStatus = exports.AgreementListData = exports.Metadata = exports.MediaItem = exports.PublishInfo = exports.MetadataFilter = exports.MetadataQuery = exports.MediaItemPopulationQuery = exports.MediaItemStates = exports.MediaItemSortOrders = exports.MediaItemFilter = exports.MediaItemQuery = exports.MediaService = void 0;
var IVFilter_1 = __webpack_require__(/*! ./IVFilter */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/IVFilter.ts");
var MediaService = (function () {
    function MediaService() {
    }
    MediaService.Find = function (client, query) {
        return new Promise(function (resolve, reject) {
            client.post({ path: "MediaService/Find", data: query }, resolve, reject);
        });
    };
    MediaService.FindSync = function (client, query) {
        return client.postSync({ path: "MediaService/Find", data: query });
    };
    return MediaService;
}());
exports.MediaService = MediaService;
var MediaItemQuery = (function () {
    function MediaItemQuery() {
    }
    return MediaItemQuery;
}());
exports.MediaItemQuery = MediaItemQuery;
var MediaItemFilter = (function (_super) {
    __extends(MediaItemFilter, _super);
    function MediaItemFilter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return MediaItemFilter;
}(IVFilter_1.IVFilter));
exports.MediaItemFilter = MediaItemFilter;
var MediaItemSortOrders;
(function (MediaItemSortOrders) {
    MediaItemSortOrders[MediaItemSortOrders["None"] = 0] = "None";
    MediaItemSortOrders[MediaItemSortOrders["Name"] = 1] = "Name";
    MediaItemSortOrders[MediaItemSortOrders["NameDescending"] = 2] = "NameDescending";
    MediaItemSortOrders[MediaItemSortOrders["DateAdded"] = 3] = "DateAdded";
    MediaItemSortOrders[MediaItemSortOrders["DateAddedDescending"] = 4] = "DateAddedDescending";
    MediaItemSortOrders[MediaItemSortOrders["MediaItemId"] = 5] = "MediaItemId";
    MediaItemSortOrders[MediaItemSortOrders["MediaItemIdDescending"] = 6] = "MediaItemIdDescending";
})(MediaItemSortOrders || (exports.MediaItemSortOrders = MediaItemSortOrders = {}));
var MediaItemStates;
(function (MediaItemStates) {
    MediaItemStates[MediaItemStates["CreatedInCore"] = 0] = "CreatedInCore";
    MediaItemStates[MediaItemStates["MetadataAnalyzed"] = 1] = "MetadataAnalyzed";
    MediaItemStates[MediaItemStates["OriginalContentStored"] = 2] = "OriginalContentStored";
    MediaItemStates[MediaItemStates["AnalyzedAndStored"] = 3] = "AnalyzedAndStored";
    MediaItemStates[MediaItemStates["MetadataOrganized"] = 4] = "MetadataOrganized";
    MediaItemStates[MediaItemStates["MediaReadyToUse"] = 7] = "MediaReadyToUse";
})(MediaItemStates || (exports.MediaItemStates = MediaItemStates = {}));
var MediaItemPopulationQuery = (function () {
    function MediaItemPopulationQuery() {
    }
    return MediaItemPopulationQuery;
}());
exports.MediaItemPopulationQuery = MediaItemPopulationQuery;
var MetadataQuery = (function () {
    function MetadataQuery() {
    }
    return MetadataQuery;
}());
exports.MetadataQuery = MetadataQuery;
var MetadataFilter = (function (_super) {
    __extends(MetadataFilter, _super);
    function MetadataFilter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return MetadataFilter;
}(IVFilter_1.IVFilter));
exports.MetadataFilter = MetadataFilter;
var PublishInfo = (function () {
    function PublishInfo() {
    }
    return PublishInfo;
}());
exports.PublishInfo = PublishInfo;
var MediaItem = (function () {
    function MediaItem() {
    }
    return MediaItem;
}());
exports.MediaItem = MediaItem;
var Metadata = (function () {
    function Metadata() {
    }
    return Metadata;
}());
exports.Metadata = Metadata;
var AgreementListData = (function () {
    function AgreementListData() {
    }
    return AgreementListData;
}());
exports.AgreementListData = AgreementListData;
var ValidToDateStatus;
(function (ValidToDateStatus) {
    ValidToDateStatus[ValidToDateStatus["Valid"] = 1] = "Valid";
    ValidToDateStatus[ValidToDateStatus["SoonExpired"] = 5] = "SoonExpired";
    ValidToDateStatus[ValidToDateStatus["Expired"] = 2] = "Expired";
})(ValidToDateStatus || (exports.ValidToDateStatus = ValidToDateStatus = {}));
var AgreementState;
(function (AgreementState) {
    AgreementState[AgreementState["Awaiting"] = 0] = "Awaiting";
    AgreementState[AgreementState["Agreed"] = 1] = "Agreed";
    AgreementState[AgreementState["Disagreed"] = 2] = "Disagreed";
    AgreementState[AgreementState["Expired"] = 4] = "Expired";
    AgreementState[AgreementState["AgreedButExpired"] = 5] = "AgreedButExpired";
    AgreementState[AgreementState["SoonExpired"] = 8] = "SoonExpired";
    AgreementState[AgreementState["AgreedButSoonExpired"] = 9] = "AgreedButSoonExpired";
    AgreementState[AgreementState["DisagreedAndExpired"] = 6] = "DisagreedAndExpired";
    AgreementState[AgreementState["DisagreedAndSoonExpired"] = 10] = "DisagreedAndSoonExpired";
    AgreementState[AgreementState["Removed"] = 16] = "Removed";
})(AgreementState || (exports.AgreementState = AgreementState = {}));
var ConsentUserAgreementData = (function () {
    function ConsentUserAgreementData() {
    }
    return ConsentUserAgreementData;
}());
exports.ConsentUserAgreementData = ConsentUserAgreementData;
var ConsentStatus;
(function (ConsentStatus) {
    ConsentStatus[ConsentStatus["NotSet"] = 0] = "NotSet";
    ConsentStatus[ConsentStatus["Agreed"] = 1] = "Agreed";
    ConsentStatus[ConsentStatus["Disagreed"] = 2] = "Disagreed";
})(ConsentStatus || (exports.ConsentStatus = ConsentStatus = {}));
var LegalBasis;
(function (LegalBasis) {
    LegalBasis[LegalBasis["Consent"] = 1] = "Consent";
    LegalBasis[LegalBasis["Agreement"] = 2] = "Agreement";
    LegalBasis[LegalBasis["LegalObligation"] = 3] = "LegalObligation";
    LegalBasis[LegalBasis["ProtectRegistrantsVitalInterests"] = 4] = "ProtectRegistrantsVitalInterests";
    LegalBasis[LegalBasis["PublicInterest"] = 5] = "PublicInterest";
    LegalBasis[LegalBasis["LegitimateInterest"] = 6] = "LegitimateInterest";
})(LegalBasis || (exports.LegalBasis = LegalBasis = {}));
var AssetStates;
(function (AssetStates) {
    AssetStates[AssetStates["None"] = 0] = "None";
    AssetStates[AssetStates["MediaShared"] = 1] = "MediaShared";
    AssetStates[AssetStates["MediaPublished"] = 2] = "MediaPublished";
})(AssetStates || (exports.AssetStates = AssetStates = {}));
var Media = (function () {
    function Media() {
    }
    return Media;
}());
exports.Media = Media;
var WebMedia = (function (_super) {
    __extends(WebMedia, _super);
    function WebMedia() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return WebMedia;
}(Media));
exports.WebMedia = WebMedia;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MetadataDefinitionService.ts":
/*!*******************************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MetadataDefinitionService.ts ***!
  \*******************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.MetadataDefinitionType = exports.MetadataType = exports.MetadataDefinitionMapping = exports.MetadataDefinition = exports.MetadataDefinitionPopulationQuery = exports.MetadataDefinitionFilter = exports.MetadataDefinitionQuery = exports.MetadataDefinitionService = void 0;
var IVFilter_1 = __webpack_require__(/*! ./IVFilter */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/IVFilter.ts");
var MetadataDefinitionService = (function () {
    function MetadataDefinitionService() {
    }
    MetadataDefinitionService.Find = function (client, q) {
        return new Promise(function (resolve, reject) {
            client.post({ path: "MetadataDefinitionService/Find", data: q }, resolve, reject);
        });
    };
    return MetadataDefinitionService;
}());
exports.MetadataDefinitionService = MetadataDefinitionService;
var MetadataDefinitionQuery = (function () {
    function MetadataDefinitionQuery() {
    }
    return MetadataDefinitionQuery;
}());
exports.MetadataDefinitionQuery = MetadataDefinitionQuery;
var MetadataDefinitionFilter = (function (_super) {
    __extends(MetadataDefinitionFilter, _super);
    function MetadataDefinitionFilter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return MetadataDefinitionFilter;
}(IVFilter_1.IVFilter));
exports.MetadataDefinitionFilter = MetadataDefinitionFilter;
var MetadataDefinitionPopulationQuery = (function () {
    function MetadataDefinitionPopulationQuery() {
    }
    return MetadataDefinitionPopulationQuery;
}());
exports.MetadataDefinitionPopulationQuery = MetadataDefinitionPopulationQuery;
var MetadataDefinition = (function () {
    function MetadataDefinition() {
    }
    return MetadataDefinition;
}());
exports.MetadataDefinition = MetadataDefinition;
var MetadataDefinitionMapping = (function () {
    function MetadataDefinitionMapping() {
    }
    return MetadataDefinitionMapping;
}());
exports.MetadataDefinitionMapping = MetadataDefinitionMapping;
var MetadataType;
(function (MetadataType) {
    MetadataType[MetadataType["Undefined"] = 0] = "Undefined";
    MetadataType[MetadataType["String"] = 1] = "String";
    MetadataType[MetadataType["DateTime"] = 2] = "DateTime";
    MetadataType[MetadataType["Integer"] = 3] = "Integer";
    MetadataType[MetadataType["Boolean"] = 4] = "Boolean";
    MetadataType[MetadataType["LongString"] = 5] = "LongString";
    MetadataType[MetadataType["Decimal"] = 6] = "Decimal";
})(MetadataType || (exports.MetadataType = MetadataType = {}));
var MetadataDefinitionType;
(function (MetadataDefinitionType) {
    MetadataDefinitionType[MetadataDefinitionType["Undefined"] = 0] = "Undefined";
    MetadataDefinitionType[MetadataDefinitionType["System"] = 1] = "System";
    MetadataDefinitionType[MetadataDefinitionType["User"] = 2] = "User";
    MetadataDefinitionType[MetadataDefinitionType["Iptc"] = 3] = "Iptc";
    MetadataDefinitionType[MetadataDefinitionType["Exif"] = 4] = "Exif";
    MetadataDefinitionType[MetadataDefinitionType["Xmp"] = 5] = "Xmp";
    MetadataDefinitionType[MetadataDefinitionType["Id3V1"] = 6] = "Id3V1";
    MetadataDefinitionType[MetadataDefinitionType["Id3V2"] = 7] = "Id3V2";
    MetadataDefinitionType[MetadataDefinitionType["Riff"] = 8] = "Riff";
    MetadataDefinitionType[MetadataDefinitionType["Jfif"] = 9] = "Jfif";
    MetadataDefinitionType[MetadataDefinitionType["Gps"] = 10] = "Gps";
    MetadataDefinitionType[MetadataDefinitionType["PhotoshopIrb"] = 11] = "PhotoshopIrb";
    MetadataDefinitionType[MetadataDefinitionType["FlashPix"] = 12] = "FlashPix";
    MetadataDefinitionType[MetadataDefinitionType["Afcp"] = 13] = "Afcp";
    MetadataDefinitionType[MetadataDefinitionType["GeoTiff"] = 14] = "GeoTiff";
    MetadataDefinitionType[MetadataDefinitionType["IccProfile"] = 15] = "IccProfile";
    MetadataDefinitionType[MetadataDefinitionType["WindowsMedia"] = 16] = "WindowsMedia";
    MetadataDefinitionType[MetadataDefinitionType["PdfDocInfo"] = 17] = "PdfDocInfo";
    MetadataDefinitionType[MetadataDefinitionType["Dicom"] = 100] = "Dicom";
    MetadataDefinitionType[MetadataDefinitionType["ThirdParty"] = 101] = "ThirdParty";
    MetadataDefinitionType[MetadataDefinitionType["YouTube"] = 102] = "YouTube";
    MetadataDefinitionType[MetadataDefinitionType["Vidispine"] = 103] = "Vidispine";
    MetadataDefinitionType[MetadataDefinitionType["Spotify"] = 104] = "Spotify";
    MetadataDefinitionType[MetadataDefinitionType["Custom"] = 200] = "Custom";
    MetadataDefinitionType[MetadataDefinitionType["Image"] = 201] = "Image";
    MetadataDefinitionType[MetadataDefinitionType["Video"] = 202] = "Video";
    MetadataDefinitionType[MetadataDefinitionType["Audio"] = 203] = "Audio";
    MetadataDefinitionType[MetadataDefinitionType["Document"] = 204] = "Document";
    MetadataDefinitionType[MetadataDefinitionType["MakerNotesCanon"] = 1001] = "MakerNotesCanon";
    MetadataDefinitionType[MetadataDefinitionType["MakerNotesCasio"] = 1002] = "MakerNotesCasio";
    MetadataDefinitionType[MetadataDefinitionType["MakerNotesFujiFilm"] = 1003] = "MakerNotesFujiFilm";
    MetadataDefinitionType[MetadataDefinitionType["MakerNotesGe"] = 1004] = "MakerNotesGe";
    MetadataDefinitionType[MetadataDefinitionType["MakerNotesHp"] = 1005] = "MakerNotesHp";
    MetadataDefinitionType[MetadataDefinitionType["MakerNotesJvcVictor"] = 1006] = "MakerNotesJvcVictor";
    MetadataDefinitionType[MetadataDefinitionType["MakerNotesKodak"] = 1007] = "MakerNotesKodak";
    MetadataDefinitionType[MetadataDefinitionType["MakerNotesLeaf"] = 1008] = "MakerNotesLeaf";
    MetadataDefinitionType[MetadataDefinitionType["MakerNotesMinoltaKonicaMinolta"] = 1009] = "MakerNotesMinoltaKonicaMinolta";
    MetadataDefinitionType[MetadataDefinitionType["MakerNotesNikon"] = 1010] = "MakerNotesNikon";
    MetadataDefinitionType[MetadataDefinitionType["MakerNotesOlympusEpson"] = 1011] = "MakerNotesOlympusEpson";
    MetadataDefinitionType[MetadataDefinitionType["MakerNotesPanasonicLeica"] = 1012] = "MakerNotesPanasonicLeica";
    MetadataDefinitionType[MetadataDefinitionType["UserDefined1"] = 10001] = "UserDefined1";
    MetadataDefinitionType[MetadataDefinitionType["UserDefined2"] = 10002] = "UserDefined2";
    MetadataDefinitionType[MetadataDefinitionType["UserDefined3"] = 10003] = "UserDefined3";
    MetadataDefinitionType[MetadataDefinitionType["UserDefined4"] = 10004] = "UserDefined4";
    MetadataDefinitionType[MetadataDefinitionType["UserDefined5"] = 10005] = "UserDefined5";
    MetadataDefinitionType[MetadataDefinitionType["UserDefined6"] = 10006] = "UserDefined6";
    MetadataDefinitionType[MetadataDefinitionType["UserDefined7"] = 10007] = "UserDefined7";
    MetadataDefinitionType[MetadataDefinitionType["UserDefined8"] = 10008] = "UserDefined8";
    MetadataDefinitionType[MetadataDefinitionType["UserDefined9"] = 10009] = "UserDefined9";
})(MetadataDefinitionType || (exports.MetadataDefinitionType = MetadataDefinitionType = {}));


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/VaultService.ts":
/*!******************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/VaultService.ts ***!
  \******************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Vault = exports.VaultPopulationQuery = exports.VaultRoles = exports.VaultFilter = exports.VaultQuery = exports.VaultService = void 0;
var IVFilter_1 = __webpack_require__(/*! ./IVFilter */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/IVFilter.ts");
var VaultService = (function () {
    function VaultService() {
    }
    VaultService.Find = function (client, query) {
        return new Promise(function (resolve, reject) {
            client.post({ path: "VaultService/Find", data: query }, resolve, reject);
        });
    };
    return VaultService;
}());
exports.VaultService = VaultService;
var VaultQuery = (function () {
    function VaultQuery() {
    }
    return VaultQuery;
}());
exports.VaultQuery = VaultQuery;
var VaultFilter = (function (_super) {
    __extends(VaultFilter, _super);
    function VaultFilter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return VaultFilter;
}(IVFilter_1.IVFilter));
exports.VaultFilter = VaultFilter;
var VaultRoles;
(function (VaultRoles) {
    VaultRoles[VaultRoles["FullControl"] = 7] = "FullControl";
    VaultRoles[VaultRoles["Contribute"] = 3] = "Contribute";
    VaultRoles[VaultRoles["View"] = 1] = "View";
    VaultRoles[VaultRoles["None"] = 0] = "None";
    VaultRoles[VaultRoles["AccessRightsWrite"] = 2] = "AccessRightsWrite";
    VaultRoles[VaultRoles["AccessRightsAdmin"] = 4] = "AccessRightsAdmin";
})(VaultRoles || (exports.VaultRoles = VaultRoles = {}));
var VaultPopulationQuery = (function () {
    function VaultPopulationQuery() {
    }
    return VaultPopulationQuery;
}());
exports.VaultPopulationQuery = VaultPopulationQuery;
var Vault = (function () {
    function Vault() {
    }
    return Vault;
}());
exports.Vault = Vault;


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/util/AgreementStateExtensions.ts":
/*!**************************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/util/AgreementStateExtensions.ts ***!
  \**************************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AgreementStateExtensions = void 0;
var MediaService_1 = __webpack_require__(/*! ../services/MediaService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MediaService.ts");
var AgreementSymbolStates_1 = __webpack_require__(/*! ../data/AgreementSymbolStates */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/data/AgreementSymbolStates.ts");
var AgreementStateExtensions = exports.AgreementStateExtensions = (function () {
    function AgreementStateExtensions() {
    }
    AgreementStateExtensions.getAgreementSymbolState = function (agreementState) {
        switch (agreementState) {
            case MediaService_1.AgreementState.Agreed: return AgreementSymbolStates_1.AgreementSymbolStates.Valid;
            case MediaService_1.AgreementState.AgreedButSoonExpired: return AgreementSymbolStates_1.AgreementSymbolStates.ValidButSoonInvalid;
            case MediaService_1.AgreementState.Awaiting: return AgreementSymbolStates_1.AgreementSymbolStates.NotSet;
            case MediaService_1.AgreementState.SoonExpired: return AgreementSymbolStates_1.AgreementSymbolStates.NotSet;
            default: return AgreementSymbolStates_1.AgreementSymbolStates.Invalid;
        }
    };
    ;
    AgreementStateExtensions.adjustByExpiration = function (state, validToDate) {
        state &= ~(MediaService_1.AgreementState.Expired | MediaService_1.AgreementState.SoonExpired);
        if (validToDate == null || state == MediaService_1.AgreementState.Removed)
            return state;
        var utcNow = new Date();
        var soonDate = new Date(utcNow.getTime() + this.SoonSpan);
        if (validToDate < utcNow) {
            return state | MediaService_1.AgreementState.Expired;
        }
        if (validToDate < soonDate) {
            return state | MediaService_1.AgreementState.SoonExpired;
        }
        return state;
    };
    AgreementStateExtensions.SoonSpan = 3 * 30 * 24 * 60 * 60 * 1000;
    return AgreementStateExtensions;
}());


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/util/AssetSymbolHelper.ts":
/*!*******************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/util/AssetSymbolHelper.ts ***!
  \*******************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AssetSymbolHelper = void 0;
var DateUtil_1 = __webpack_require__(/*! ../../../../../../ImageVault.Symbol/src/DateUtil */ "./ImageVault.Symbol/src/DateUtil.ts");
var MediaService_1 = __webpack_require__(/*! ../services/MediaService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MediaService.ts");
var AgreementSymbolStates_1 = __webpack_require__(/*! ../data/AgreementSymbolStates */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/data/AgreementSymbolStates.ts");
var ApiVersion_1 = __webpack_require__(/*! ../data/ApiVersion */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/data/ApiVersion.ts");
var AgreementStateExtensions_1 = __webpack_require__(/*! ./AgreementStateExtensions */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/util/AgreementStateExtensions.ts");
var ConsentUserAgreementDataExtensions_1 = __webpack_require__(/*! ./ConsentUserAgreementDataExtensions */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/util/ConsentUserAgreementDataExtensions.ts");
var AssetSymbol_1 = __webpack_require__(/*! ../data/AssetSymbol */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/data/AssetSymbol.ts");
var AssetSymbolHelper = exports.AssetSymbolHelper = (function () {
    function AssetSymbolHelper(apiVersion) {
        this._symbolsDict = new Map();
        this._apiVersion = apiVersion;
    }
    AssetSymbolHelper.prototype.addAgreement = function (libraryItemAgreement) {
        var validToDate = DateUtil_1.DateUtil.toJavaScriptDate(libraryItemAgreement.ValidToDate);
        this.addAgreementSymbol(validToDate, libraryItemAgreement.AgreementIdentifier, libraryItemAgreement.LegalBasis);
    };
    AssetSymbolHelper.prototype.getSymbol = function (status) {
        var statusString = status;
        if (!isNaN(statusString))
            statusString = AgreementSymbolStates_1.AgreementSymbolStates[status];
        return statusString.toString().toLocaleLowerCase();
    };
    AssetSymbolHelper.prototype.getLegalBasisName = function (legalBasis) {
        var legalBasisString = legalBasis;
        if (!isNaN(legalBasisString))
            legalBasisString = MediaService_1.LegalBasis[legalBasis];
        return legalBasisString.toString();
    };
    AssetSymbolHelper.prototype.addAgreementSymbol = function (agreementValidToDate, agreementIdentifier, agreementLegalBasis) {
        var agreementState = AgreementStateExtensions_1.AgreementStateExtensions.adjustByExpiration(MediaService_1.AgreementState.Agreed, agreementValidToDate);
        var agreementSymbolState = AgreementStateExtensions_1.AgreementStateExtensions.getAgreementSymbolState(agreementState);
        var symbol = this.getSymbol(agreementSymbolState);
        var assetSymbol;
        if (!this._symbolsDict.has(symbol)) {
            assetSymbol = new AssetSymbol_1.AssetSymbol(symbol, []);
            this._symbolsDict.set(symbol, assetSymbol);
        }
        else {
            assetSymbol = this._symbolsDict.get(symbol);
        }
        assetSymbol.info.push({
            name: agreementIdentifier,
            value: this.getLegalBasisName(agreementLegalBasis),
            symbol: symbol,
            group: AssetSymbolHelper.GroupAgreement
        });
    };
    AssetSymbolHelper.prototype.addConsent = function (consentData) {
        if (this._apiVersion < ApiVersion_1.ApiVersion.V526)
            return;
        var agreementSymbolState = ConsentUserAgreementDataExtensions_1.ConsentUserAgreementDataExtensions.getAgreementSymbolState(consentData);
        var symbol = this.getSymbol(agreementSymbolState);
        var assetSymbol;
        if (!this._symbolsDict.has(symbol)) {
            assetSymbol = new AssetSymbol_1.AssetSymbol(symbol, []);
            this._symbolsDict.set(symbol, assetSymbol);
        }
        else {
            assetSymbol = this._symbolsDict.get(symbol);
        }
        assetSymbol.info.push({
            name: consentData.consentUserName,
            value: consentData.consentAgreementName,
            symbol: symbol,
            group: AssetSymbolHelper.GroupConsent
        });
    };
    AssetSymbolHelper.prototype.addMetadata = function (metadata) {
        if (!metadata.Value || !metadata.SymbolKey)
            return;
        this.addMetadataSymbol(metadata.SymbolKey, metadata.Name, metadata.Value.toString());
    };
    AssetSymbolHelper.prototype.addMetadataSymbol = function (metadataDefinitionSymbolKey, metadataDefinitionName, metadataValue) {
        var assetSymbol;
        var symbol = metadataDefinitionSymbolKey.toLowerCase();
        if (this._symbolsDict.has(symbol)) {
            assetSymbol = this._symbolsDict.get(symbol);
        }
        else {
            assetSymbol = new AssetSymbol_1.AssetSymbol(symbol, []);
            this._symbolsDict.set(symbol, assetSymbol);
        }
        assetSymbol.info.push({
            name: metadataDefinitionName,
            value: metadataValue,
            group: null,
            symbol: null
        });
    };
    AssetSymbolHelper.prototype.hasMixedStatuses = function (valid, validButSoonInvalid, notSet, invalid) {
        var isValid = valid != null || validButSoonInvalid != null;
        var isNotSet = notSet != null;
        var isInvalid = invalid != null;
        if (isValid && (isNotSet || isInvalid))
            return true;
        return isNotSet && isInvalid;
    };
    AssetSymbolHelper.prototype.unifyAgreementSymbols = function () {
        var validSymbol = this.extractAgreementSymbol(AgreementSymbolStates_1.AgreementSymbolStates.Valid);
        var validButSoonInvalidSymbol = this.extractAgreementSymbol(AgreementSymbolStates_1.AgreementSymbolStates.ValidButSoonInvalid);
        var notSetSymbol = this.extractAgreementSymbol(AgreementSymbolStates_1.AgreementSymbolStates.NotSet);
        var invalidSymbol = this.extractAgreementSymbol(AgreementSymbolStates_1.AgreementSymbolStates.Invalid);
        var targetStatus;
        if (this.hasMixedStatuses(validSymbol, validButSoonInvalidSymbol, notSetSymbol, invalidSymbol)) {
            targetStatus = AgreementSymbolStates_1.AgreementSymbolStates.Mixed;
        }
        else if (invalidSymbol != null) {
            targetStatus = AgreementSymbolStates_1.AgreementSymbolStates.Invalid;
        }
        else if (notSetSymbol != null) {
            targetStatus = AgreementSymbolStates_1.AgreementSymbolStates.NotSet;
        }
        else if (validSymbol != null || validButSoonInvalidSymbol != null) {
            targetStatus = AgreementSymbolStates_1.AgreementSymbolStates.Valid;
        }
        else {
            return;
        }
        var targetSymbol = {
            symbol: this.getSymbol(targetStatus),
            info: []
        };
        var allInfo = [];
        if (validSymbol != null) {
            allInfo = allInfo.concat(validSymbol.info);
        }
        if (validButSoonInvalidSymbol != null) {
            allInfo = allInfo.concat(validButSoonInvalidSymbol.info);
        }
        if (notSetSymbol != null) {
            allInfo = allInfo.concat(notSetSymbol.info);
        }
        if (invalidSymbol != null) {
            allInfo = allInfo.concat(invalidSymbol.info);
        }
        targetSymbol.info = allInfo;
        var sortFunction = function (a, b) {
            var cmp = function (a, b) {
                if (a == null && b == null)
                    return 0;
                if (a == null)
                    return -1;
                if (b == null)
                    return 1;
                return a.localeCompare(b);
            };
            var gc = cmp(a.group, b.group);
            if (gc != 0)
                return gc;
            var nc = cmp(a.name, b.name);
            if (nc != 0)
                return nc;
            return cmp(a.value, b.value);
        };
        targetSymbol.info.sort(sortFunction);
        this._symbolsDict.set(this.getSymbol(targetStatus), targetSymbol);
    };
    AssetSymbolHelper.prototype.extractAgreementSymbol = function (status) {
        var key = this.getSymbol(status);
        if (!this._symbolsDict.has(key))
            return null;
        var symbol = this._symbolsDict.get(key);
        this._symbolsDict.delete(key);
        return symbol;
    };
    AssetSymbolHelper.prototype.toAssetSymbolList = function () {
        this.unifyAgreementSymbols();
        this.fixLegacySymbols();
        return (this._symbolsDict.size > 0 ? Array.from(this._symbolsDict.values()) : []);
    };
    AssetSymbolHelper.prototype.fixLegacySymbols = function () {
        var e_1, _a;
        var _this = this;
        if (this._apiVersion > ApiVersion_1.ApiVersion.V0)
            return;
        var keys = this._symbolsDict.keys();
        try {
            for (var keys_1 = __values(keys), keys_1_1 = keys_1.next(); !keys_1_1.done; keys_1_1 = keys_1.next()) {
                var symbolName = keys_1_1.value;
                var legacySymbol = this.translateV0SymbolName(symbolName);
                if (legacySymbol == null) {
                    continue;
                }
                var val = this._symbolsDict.get(symbolName);
                val.info.forEach(function (assetSymbolInfo) {
                    if (assetSymbolInfo.symbol != null) {
                        assetSymbolInfo.symbol = _this.translateV0SymbolName(assetSymbolInfo.symbol);
                    }
                });
                if (legacySymbol.toUpperCase() == symbolName.toUpperCase())
                    continue;
                val.symbol = legacySymbol;
                this._symbolsDict.set(legacySymbol, val);
                this._symbolsDict.delete(symbolName);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (keys_1_1 && !keys_1_1.done && (_a = keys_1.return)) _a.call(keys_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    AssetSymbolHelper.prototype.translateV0SymbolName = function (symbolsDictKey) {
        if (!symbolsDictKey)
            return null;
        if (symbolsDictKey.toUpperCase() == MediaService_1.ValidToDateStatus.Expired.toString().toUpperCase() ||
            symbolsDictKey.toUpperCase() == MediaService_1.ValidToDateStatus.SoonExpired.toString().toUpperCase() ||
            symbolsDictKey.toUpperCase() == MediaService_1.ValidToDateStatus.Valid.toString().toUpperCase()) {
            return symbolsDictKey;
        }
        if (symbolsDictKey.toUpperCase() == AgreementSymbolStates_1.AgreementSymbolStates.Mixed.toString().toUpperCase() ||
            symbolsDictKey.toUpperCase() == AgreementSymbolStates_1.AgreementSymbolStates.NotSet.toString().toUpperCase() ||
            symbolsDictKey.toUpperCase() == AgreementSymbolStates_1.AgreementSymbolStates.ValidButSoonInvalid.toString().toUpperCase()) {
            return MediaService_1.ValidToDateStatus.SoonExpired.toString().toLowerCase();
        }
        if (symbolsDictKey.toUpperCase() == AgreementSymbolStates_1.AgreementSymbolStates.Invalid.toString().toUpperCase()) {
            return MediaService_1.ValidToDateStatus.Expired.toString().toLowerCase();
        }
        return null;
    };
    AssetSymbolHelper.GroupAgreement = "agreement";
    AssetSymbolHelper.GroupConsent = "consent";
    return AssetSymbolHelper;
}());


/***/ }),

/***/ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/util/ConsentUserAgreementDataExtensions.ts":
/*!************************************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/util/ConsentUserAgreementDataExtensions.ts ***!
  \************************************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ConsentUserAgreementDataExtensions = void 0;
var DateUtil_1 = __webpack_require__(/*! ../../../../../../ImageVault.Symbol/src/DateUtil */ "./ImageVault.Symbol/src/DateUtil.ts");
var MediaService_1 = __webpack_require__(/*! ../services/MediaService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MediaService.ts");
var AgreementStateExtensions_1 = __webpack_require__(/*! ./AgreementStateExtensions */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/util/AgreementStateExtensions.ts");
var ConsentUserAgreementDataExtensions = (function () {
    function ConsentUserAgreementDataExtensions() {
    }
    ConsentUserAgreementDataExtensions.getAgreementSymbolState = function (consentUserAgreementData) {
        var agreementState = ConsentUserAgreementDataExtensions.getAgreementState(consentUserAgreementData);
        return AgreementStateExtensions_1.AgreementStateExtensions.getAgreementSymbolState(agreementState);
    };
    ConsentUserAgreementDataExtensions.getAgreementState = function (consentData) {
        var validToDate = DateUtil_1.DateUtil.toJavaScriptDate(consentData.validToDate);
        var status = consentData.status || MediaService_1.ConsentStatus.NotSet;
        switch (status) {
            case MediaService_1.ConsentStatus.NotSet: return AgreementStateExtensions_1.AgreementStateExtensions.adjustByExpiration(MediaService_1.AgreementState.Awaiting, validToDate);
            case MediaService_1.ConsentStatus.Disagreed: return AgreementStateExtensions_1.AgreementStateExtensions.adjustByExpiration(MediaService_1.AgreementState.Disagreed, validToDate);
            case MediaService_1.ConsentStatus.Agreed: return AgreementStateExtensions_1.AgreementStateExtensions.adjustByExpiration(MediaService_1.AgreementState.Agreed, validToDate);
            default: return MediaService_1.AgreementState.Awaiting;
        }
    };
    return ConsentUserAgreementDataExtensions;
}());
exports.ConsentUserAgreementDataExtensions = ConsentUserAgreementDataExtensions;


/***/ }),

/***/ "./ImageVault.Symbol/src/DateUtil.ts":
/*!*******************************************!*\
  !*** ./ImageVault.Symbol/src/DateUtil.ts ***!
  \*******************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.DateUtil = void 0;
var DateUtil = (function () {
    function DateUtil() {
    }
    DateUtil.toJavaScriptDate = function (value) {
        if (!value)
            return null;
        if (typeof value === 'number')
            return new Date(value);
        if (typeof value === 'object')
            return value;
        var pattern = /Date\(([^)]+)\)/;
        var results = pattern.exec(value);
        if (results) {
            return new Date(parseFloat(results[1]));
        }
        var yearMonthDatePattern = /^(\d{4})-(\d{2})-(\d{2})$/;
        var ymdResult = yearMonthDatePattern.exec(value);
        if (ymdResult) {
            return new Date(parseInt(ymdResult[1]), parseInt(ymdResult[2]) - 1, parseInt(ymdResult[3]));
        }
        var isoPattern = /[\+-]\d+:\d+$/;
        if (isoPattern.test(value))
            return new Date(value);
        if (!value.endsWith("Z"))
            value += "Z";
        return new Date(value);
    };
    return DateUtil;
}());
exports.DateUtil = DateUtil;


/***/ }),

/***/ "jquery":
/*!********************!*\
  !*** external "$" ***!
  \********************/
/***/ ((module) => {

"use strict";
module.exports = $;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";
var exports = __webpack_exports__;
/*!*************************************************************************************************!*\
  !*** ./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/PinClientExports.ts ***!
  \*************************************************************************************************/

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ApiVersion = exports.AssetSymbolHelper = exports.ValidToDateStatus = exports.ConsentUserAgreementData = exports.ConsentStatus = exports.AgreementListData = exports.AgreementState = exports.DateUtil = exports.VaultService = exports.MetadataType = exports.MetadataDefinitionType = exports.MetadataDefinitionService = exports.MediaService = exports.MediaItemStates = exports.MediaItemSortOrders = exports.LegalBasis = exports.AssetStates = exports.MediaFormatService = exports.CategoryService = exports.AssetService = exports.PinClient = exports.ActivationResponseState = exports.Util = exports.UriUtil = exports.ImageLoader = exports.WebMediaFormat = exports.ThumbnailFormat = exports.OriginalFormat = exports.MediaFormatOutputType = exports.ImageFormat = exports.ResizeEffect = exports.CropEffect = exports.ClientCredentialsClient = exports.Client = exports.ImageVault = void 0;
var ClientCredentialsClient_1 = __webpack_require__(/*! ./ClientCredentialsClient */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ClientCredentialsClient.ts");
Object.defineProperty(exports, "ClientCredentialsClient", ({ enumerable: true, get: function () { return ClientCredentialsClient_1.ClientCredentialsClient; } }));
var effects_1 = __webpack_require__(/*! ./effects */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/effects.ts");
Object.defineProperty(exports, "CropEffect", ({ enumerable: true, get: function () { return effects_1.CropEffect; } }));
Object.defineProperty(exports, "ResizeEffect", ({ enumerable: true, get: function () { return effects_1.ResizeEffect; } }));
var formats_1 = __webpack_require__(/*! ./formats */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/formats.ts");
Object.defineProperty(exports, "ImageFormat", ({ enumerable: true, get: function () { return formats_1.ImageFormat; } }));
Object.defineProperty(exports, "MediaFormatOutputType", ({ enumerable: true, get: function () { return formats_1.MediaFormatOutputType; } }));
Object.defineProperty(exports, "OriginalFormat", ({ enumerable: true, get: function () { return formats_1.OriginalFormat; } }));
Object.defineProperty(exports, "ThumbnailFormat", ({ enumerable: true, get: function () { return formats_1.ThumbnailFormat; } }));
Object.defineProperty(exports, "WebMediaFormat", ({ enumerable: true, get: function () { return formats_1.WebMediaFormat; } }));
var imagevault_client_1 = __webpack_require__(/*! ./imagevault-client */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/imagevault-client.ts");
Object.defineProperty(exports, "Client", ({ enumerable: true, get: function () { return imagevault_client_1.Client; } }));
var ImageLoader_1 = __webpack_require__(/*! ./lib/ImageLoader */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/ImageLoader.ts");
Object.defineProperty(exports, "ImageLoader", ({ enumerable: true, get: function () { return ImageLoader_1.ImageLoader; } }));
var UriUtil_1 = __webpack_require__(/*! ./lib/UriUtil */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/UriUtil.ts");
Object.defineProperty(exports, "UriUtil", ({ enumerable: true, get: function () { return UriUtil_1.UriUtil; } }));
var Util_1 = __webpack_require__(/*! ./lib/Util */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Util.ts");
Object.defineProperty(exports, "Util", ({ enumerable: true, get: function () { return Util_1.Util; } }));
var PinClient_1 = __webpack_require__(/*! ./PinClient */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/PinClient.ts");
Object.defineProperty(exports, "ActivationResponseState", ({ enumerable: true, get: function () { return PinClient_1.ActivationResponseState; } }));
Object.defineProperty(exports, "PinClient", ({ enumerable: true, get: function () { return PinClient_1.PinClient; } }));
var AssetService_1 = __webpack_require__(/*! ./services/AssetService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/AssetService.ts");
Object.defineProperty(exports, "AssetService", ({ enumerable: true, get: function () { return AssetService_1.AssetService; } }));
var CategoryService_1 = __webpack_require__(/*! ./services/CategoryService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/CategoryService.ts");
Object.defineProperty(exports, "CategoryService", ({ enumerable: true, get: function () { return CategoryService_1.CategoryService; } }));
var MediaFormatService_1 = __webpack_require__(/*! ./services/MediaFormatService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MediaFormatService.ts");
Object.defineProperty(exports, "MediaFormatService", ({ enumerable: true, get: function () { return MediaFormatService_1.MediaFormatService; } }));
var MediaService_1 = __webpack_require__(/*! ./services/MediaService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MediaService.ts");
Object.defineProperty(exports, "AssetStates", ({ enumerable: true, get: function () { return MediaService_1.AssetStates; } }));
Object.defineProperty(exports, "LegalBasis", ({ enumerable: true, get: function () { return MediaService_1.LegalBasis; } }));
Object.defineProperty(exports, "MediaItemSortOrders", ({ enumerable: true, get: function () { return MediaService_1.MediaItemSortOrders; } }));
Object.defineProperty(exports, "MediaItemStates", ({ enumerable: true, get: function () { return MediaService_1.MediaItemStates; } }));
Object.defineProperty(exports, "MediaService", ({ enumerable: true, get: function () { return MediaService_1.MediaService; } }));
Object.defineProperty(exports, "AgreementState", ({ enumerable: true, get: function () { return MediaService_1.AgreementState; } }));
Object.defineProperty(exports, "AgreementListData", ({ enumerable: true, get: function () { return MediaService_1.AgreementListData; } }));
Object.defineProperty(exports, "ConsentStatus", ({ enumerable: true, get: function () { return MediaService_1.ConsentStatus; } }));
Object.defineProperty(exports, "ConsentUserAgreementData", ({ enumerable: true, get: function () { return MediaService_1.ConsentUserAgreementData; } }));
Object.defineProperty(exports, "ValidToDateStatus", ({ enumerable: true, get: function () { return MediaService_1.ValidToDateStatus; } }));
var MetadataDefinitionService_1 = __webpack_require__(/*! ./services/MetadataDefinitionService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MetadataDefinitionService.ts");
Object.defineProperty(exports, "MetadataDefinitionService", ({ enumerable: true, get: function () { return MetadataDefinitionService_1.MetadataDefinitionService; } }));
Object.defineProperty(exports, "MetadataDefinitionType", ({ enumerable: true, get: function () { return MetadataDefinitionService_1.MetadataDefinitionType; } }));
Object.defineProperty(exports, "MetadataType", ({ enumerable: true, get: function () { return MetadataDefinitionService_1.MetadataType; } }));
var VaultService_1 = __webpack_require__(/*! ./services/VaultService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/VaultService.ts");
Object.defineProperty(exports, "VaultService", ({ enumerable: true, get: function () { return VaultService_1.VaultService; } }));
var DateUtil_1 = __webpack_require__(/*! ../../../../../ImageVault.Symbol/src/DateUtil */ "./ImageVault.Symbol/src/DateUtil.ts");
Object.defineProperty(exports, "DateUtil", ({ enumerable: true, get: function () { return DateUtil_1.DateUtil; } }));
var AssetSymbolHelper_1 = __webpack_require__(/*! ./util/AssetSymbolHelper */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/util/AssetSymbolHelper.ts");
Object.defineProperty(exports, "AssetSymbolHelper", ({ enumerable: true, get: function () { return AssetSymbolHelper_1.AssetSymbolHelper; } }));
var ApiVersion_1 = __webpack_require__(/*! ./data/ApiVersion */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/data/ApiVersion.ts");
Object.defineProperty(exports, "ApiVersion", ({ enumerable: true, get: function () { return ApiVersion_1.ApiVersion; } }));
var metadataDefinitionService = __webpack_require__(/*! ./services/MetadataDefinitionService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MetadataDefinitionService.ts");
var formats = __webpack_require__(/*! ./formats */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/formats.ts");
var effects = __webpack_require__(/*! ./effects */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/effects.ts");
var pinClient = __webpack_require__(/*! ./PinClient */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/PinClient.ts");
var mediaService = __webpack_require__(/*! ./services/MediaService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MediaService.ts");
var clientCredentialsClient = __webpack_require__(/*! ./ClientCredentialsClient */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/ClientCredentialsClient.ts");
var ImageVault = (window.ImageVault = window.ImageVault || {});
exports.ImageVault = ImageVault;
var assetSymbolHelper = __webpack_require__(/*! ./util/AssetSymbolHelper */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/util/AssetSymbolHelper.ts");
var apiVersion = __webpack_require__(/*! ./data/ApiVersion */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/data/ApiVersion.ts");
ImageVault.Client = (__webpack_require__(/*! ./imagevault-client */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/imagevault-client.ts").Client);
ImageVault.PinClient = pinClient.PinClient;
ImageVault.ClientCredentialsClient = clientCredentialsClient.ClientCredentialsClient;
ImageVault.ActivationResponseState = pinClient.ActivationResponseState;
ImageVault.UriUtil = (__webpack_require__(/*! ./lib/UriUtil */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/UriUtil.ts").UriUtil);
ImageVault.ImageLoader = (__webpack_require__(/*! ./lib/ImageLoader */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/ImageLoader.ts").ImageLoader);
ImageVault.Util = (__webpack_require__(/*! ./lib/Util */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/lib/Util.ts").Util);
ImageVault.VaultService = (__webpack_require__(/*! ./services/VaultService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/VaultService.ts").VaultService);
ImageVault.MediaService = mediaService.MediaService;
ImageVault.MediaItemSortOrders = mediaService.MediaItemSortOrders;
ImageVault.MediaItemStates = mediaService.MediaItemStates;
ImageVault.AssetStates = mediaService.AssetStates;
ImageVault.LegalBasis = mediaService.LegalBasis;
ImageVault.AssetService = (__webpack_require__(/*! ./services/AssetService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/AssetService.ts").AssetService);
ImageVault.MediaFormatService = (__webpack_require__(/*! ./services/MediaFormatService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/MediaFormatService.ts").MediaFormatService);
ImageVault.CategoryService = (__webpack_require__(/*! ./services/CategoryService */ "./ImageVault.ClientScript/scripts/imagevault-client-script/scripts/ts/services/CategoryService.ts").CategoryService);
ImageVault.MetadataDefinitionService = metadataDefinitionService.MetadataDefinitionService;
ImageVault.MetadataType = metadataDefinitionService.MetadataType;
ImageVault.MetadataDefinitionType = metadataDefinitionService.MetadataDefinitionType;
ImageVault.ThumbnailFormat = formats.ThumbnailFormat;
ImageVault.MediaFormatOutputType = formats.MediaFormatOutputType;
ImageVault.OriginalFormat = formats.OriginalFormat;
ImageVault.WebMediaFormat = formats.WebMediaFormat;
ImageVault.ImageFormat = formats.ImageFormat;
ImageVault.ResizeEffect = effects.ResizeEffect;
ImageVault.CropEffect = effects.CropEffect;
ImageVault.DateUtil = DateUtil_1.DateUtil;
ImageVault.AgreementState = mediaService.AgreementState;
ImageVault.AgreementListData = mediaService.AgreementListData;
ImageVault.ConsentStatus = mediaService.ConsentStatus;
ImageVault.ConsentUserAgreementData = mediaService.ConsentUserAgreementData;
ImageVault.ValidToDateStatus = mediaService.ValidToDateStatus;
ImageVault.AssetSymbolHelper = assetSymbolHelper.AssetSymbolHelper;
ImageVault.ApiVersion = apiVersion.ApiVersion;

})();

/******/ })()
;
//# sourceMappingURL=pinClient.min.js.map